program TiTest;

{ 1991 K.Kuhn, Testing the Timer-System TIDRV.EXE }

uses crt,dos;

const nl = #13#10;

var n,UserID : Byte;
    p : Pointer;
    Timer,RAX,RBX,RCX,RDX: Word;
    i : Word;


procedure call61(var rax,rbx,rcx,rdx:word);
var r:registers;
begin
  with r do begin
    ax := rax;
    bx := rbx;
    cx := rcx;
    dx := rdx;
  end;
  intr($61,r);
  with r do begin
    rax := ax;
    rbx := bx;
    rcx := cx;
    rdx := dx;
  end;
end;


procedure AskEvents(U:Byte;Var E,V: Word);
var r:registers;
begin
  r.ah := 4;
  r.al := U;
  intr($61,r);
  V := r.al;
  E := r.dx ;
end;


begin
  GetIntVec($61,P);
  if longint(P) = 0 then begin
    writeln('TIDRV is not present.');
    EXIT;
  end;
  ClrScr;
  Writeln('TIDRV - Testprogam  V1.0');
  Writeln('========================');
  gotoxy(1,5);
  write('Testing Tic - Timers     programmed:           received:');
  RAX := 0;
  Call61(RAX,RBX,RCX,RDX);                     { Initialize Timersystem   }
  RAX := $01ff;
  Call61(RAX,RBX,RCX,RDX);                     { Login and get 255 Timers }
  if Lo(RCX) <> 0 then begin
    writeln(nl,'Login-Error: not enough timers available ',Lo(RCX));
    EXIT;
  end;
  UserID := Lo(RAX);                           { Get the UserID }
  i := 0;
  gotoxy(38,5);
  for Timer := 1 to 255 do begin
    RAX := $03*256+UserID;                 { AH: Command, AL: UserID   }
    RBX := $0100;                          { BH: Timertyp, BL:TimerMode}
    RCX := random(20);                     { CX: Timer Value           }
    RDX := Timer;                          { DX: My Timer-Number       }
    Call61(RAX,RBX,RCX,RDX);               { Progr. Timer              }
    if Lo(RCX) <> 0 then begin
      writeln('Programming-Error: no timer available or programming error');
      EXIT;
    end;
    Inc(i);
    write(i:4,#8#8#8#8);
  end;
  i := 0;
  repeat
    AskEvents(UserID,Timer,RAX);
    if Lo(RAX) <> 0 then begin
       Inc(i);
       gotoxy(58,5);
       write(i:4);
       gotoxy(1,9 );
       write('User 0:  Timer ',Timer:5,' received; AL=',Lo(RAX):3);
    end;
  until (i = 255) or keypressed;
  gotoxy(64,5);
  if i=255 then
    writeln('OK')
  else
    writeln('aborted/failed');
  i:=0;

  write('Testing Sec - Timers     programmed:           received:');
  gotoxy(38,6);
  for Timer := 001 to 255 do begin
    RAX := $03*256+UserID;                 { AH: Command, AL: UserID   }
    RBX := $0000;                          { BH: Timertyp, BL:TimerMode}
    RCX := random(4);                      { CX: Timer Value           }
    RDX := Timer;                          { DX: My Timer-Number       }
    Call61(RAX,RBX,RCX,RDX);               { Progr. Timer              }
    if RCX <> 0 then begin
      writeln('Programming-Error: no timer available or programming error');
      EXIT;
    end;
    Inc(i);
    write(i:4,#8#8#8#8);
  end;
  i := 0;
  repeat
    AskEvents(0,Timer,RAX);
    if Lo(RAX) <> 0 then begin
      Inc(i);
       gotoxy(58,6);
       write(i:4);
       gotoxy(1,9 );
       write('User 0:  Timer ',Timer:5,' received; AL=',Lo(RAX):3);
    end;
  until (i = 255) or keypressed;
  gotoxy(64,6);
  if i=255 then
    writeln('OK')
  else
    writeln('aborted/failed');

  write('Testing reload/overflow  programmed:           received:');
  i := 0;
  gotoxy(38,7);
  for Timer := 001 to 255 do begin
    RAX := $03*256+UserID;                 { AH: Command, AL: UserID   }
    RBX := $0101;                          { BH: Timertyp, BL:TimerMode}
    RCX := random(10);                     { CX: Timer Value           }
    RDX := Timer;                          { DX: My Timer-Number       }
    Call61(RAX,RBX,RCX,RDX);               { Progr. Timer              }
    if RCX <> 0 then begin
      writeln('Programming-Error: no timer available or programming error');
      EXIT;
    end;
    Inc(i);
    write(i:4,#8#8#8#8);
  end;
  i := 0;
  delay(1000);                             { after this, each timer must }
  repeat                                   { must be fired twice ->overflow}
    AskEvents(0,Timer,RAX);
    if Lo(RAX) <> 0 then begin
      gotoxy(58,7);
      write(i:4);
      gotoxy(1,9 );
      write('User 0:  Timer ',Timer:5,' received; AL=',Lo(RAX):3);
      if Lo(RAX) = 2 then begin       { Disable each overflowed timer }
        Inc(i);                       { ============================= }
        RAX := $03*256+UserID;        { AH: Command, AL: UserID   }
        RBX := $01ff;                 { BH: Timertyp, BL:TimerMode}
        RDX := Timer;                 { DX: My Timer-Number       }
        Call61(RAX,RBX,RCX,RDX);      { Progr. Timer              }
        if RCX <> 0 then begin
          writeln('Programming-Error: no timer available or programming error');
          EXIT;
        end;
      end;
    end;
  until (i = 255) or keypressed;
  gotoxy(58,7);
  write(i:4);
  gotoxy(64,7);
  if i=255 then
    writeln('OK')
  else
    writeln('aborted/failed');
  i:=0;
  gotoxy(1,9 );
  write(^g^g);
  delay(1000);
  ClrEol;
  gotoxy(1,8);
  RAX := $02 *256 + UserID;
  Call61(RAX,RBX,RCX,RDX);                    { Logout User }
end.
